<?php
/*
    PrimePayments - Удобный сервис платежей для вашего бизнеса
*/

if(file_exists('install.php')){
    die('Удалите файл install.php');
}

include_once 'lib/ConfigWritter.php';
include_once 'lib/Model.php';

$model = Model::getInstance();

$s1 = ConfigWritter::getInstance()->getParameter('SECRET_KEY_1');
$s2 = ConfigWritter::getInstance()->getParameter('SECRET_KEY_2');
$pid = ConfigWritter::getInstance()->getParameter('PROJECT_ID');
$currency = ConfigWritter::getInstance()->getParameter('CURRENCY');

$itemsCount = $_POST['sum'];
$us_account = $_POST['us_account'];

try{
    if(!$itemsCount){
        throw new Exception('Введите количество монет');
    }
    if(!$us_account){
        throw new Exception('Введите ник персонажа');
    }

    $char = $model->getChar($us_account);

    if (!$char) {
        throw new Exception('Персонаж ' . $us_account . ' не найден');
    }

    $oa = ($itemsCount * ConfigWritter::getInstance()->getParameter('ITEM_PRICE'));

    if($oa < 100){
        throw new Exception('Минимальная сумма платежа - 100 рублей');
    }
    if (!empty($char->charId)) {
        $charId = $char->charId;
    } elseif (!empty($char->obj_Id)) {
        $charId = $char->obj_Id;
    } else {
        throw new Exception('Персонаж найден, однако не удается получить его ID');
    }

    if (!$innerID = $model->createPayment(
        $charId, $oa, $itemsCount)
    ) {
        throw new Exception('Не удается создать платеж в БД. Проверьте права на запись');
    }

    $email = "id_{$innerID}@test.com";
    $sign = md5($s1 . 'initPayment' . $pid . $oa . $currency . $innerID . $email);
    $data = [
        'action'    => 'initPayment',
        'project'   => $pid,
        'sum'       => $oa,
        'currency'  => $currency,
        'innerID'   => $innerID,
        'sign'      => $sign,
        'returnLink'=> 1,
        'email'     => $email,
    ];

    $ch = curl_init('https://pay.primepayments.io/API/v2/');
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($data));

    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
    curl_setopt($ch, CURLOPT_HEADER, false);
    $json = curl_exec($ch);
    curl_close($ch);

    if(@$json){
        $json = json_decode($json, true);

        if($json['status'] == 'OK'){
            if(@$_GET['from'] == 'ajax')
                die('url:' . $json['result']);
            else
                header('Location: ' . $json['result']);
        }
    }
} catch (Exception $e) {
    die($e->getMessage());
}